var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { css, CSSResult, html, LitElement } from 'lit';
import { customElement } from 'lit/decorators.js';
import { Bubble } from '../../utils/bubble.js';
import { cssReset } from '../../utils/css-reset.js';
import '../button-el.js';
import loadFileIconURI from './icons/load-file-icon.svg';
import newFileIconURI from './icons/new-file-icon.svg';
import saveFileAsIconURI from './icons/save-file-as-icon.svg';
import saveFileIconURI from './icons/save-file-icon.svg';
let AppMenu = class AppMenu extends LitElement {
    static { this.styles = css `
    ${cssReset}

    :host {
      display: flex;
      padding: 4px;
      border-radius: 2px;

      padding: 2px;
      border-width: 1px;
      border-top-color: #ccc;
      border-left-color: #ccc;
      border-right-color: #ccc;
      border-bottom-color: #000;
      border-style: solid;
      border-radius: 2px;
      background-color: #f0f2f0;
    }
  `; }
    render() {
        return html `
      <button-el
        accesskey="o"
        icon=${loadFileIconURI}
        title="Load file [alt-o]."
        @click=${() => this.dispatchEvent(Bubble('open-file', undefined))}
      >
        Open…</button-el
      ><button-el
        accesskey="s"
        icon=${saveFileIconURI}
        title="Write file [alt-s]."
        @click=${() => this.dispatchEvent(Bubble('save-file', undefined))}
      >
        Save</button-el
      ><button-el
        icon=${saveFileAsIconURI}
        title="Open file save dialog."
        @click=${() => this.dispatchEvent(Bubble('save-file-as', undefined))}
      >
        Save As…</button-el
      ><button-el
        accesskey="n"
        icon=${newFileIconURI}
        title="Load empty file [alt-n]."
        @click=${() => this.dispatchEvent(Bubble('new-file', undefined))}
      >
        New
      </button-el>
    `;
    }
};
AppMenu = __decorate([
    customElement('app-menu')
], AppMenu);
export { AppMenu };
//# sourceMappingURL=app-menu.js.map