import { CSSResult, LitElement, type TemplateResult } from 'lit';
declare global {
    interface HTMLElementEventMap {
        drag: DragEvent;
        dragend: DragEvent;
        dragstart: DragEvent;
    }
    interface HTMLElementTagNameMap {
        'drag-area': DragArea;
    }
}
/**
 * Translates pointer events to synthetic drag events for drag-line components.
 * The element being dragged is dispatched all events unlike native DND which
 * splits between the dragged and dragged over elements. No dragover event is
 * synthesized.
 *
 * @slot - Child to translate for.
 */
export declare class DragArea extends LitElement {
    #private;
    static styles: CSSResult;
    constructor();
    protected render(): TemplateResult;
}
