import { CSSResult, LitElement, type TemplateResult } from 'lit';
import type { Group, Line, PositionLine } from '../tree/text-tree.js';
export type DragEnd = {
    readonly from: Readonly<Line>;
    readonly to: Readonly<Line | Group>;
    readonly at: PositionLine;
};
declare global {
    interface HTMLElementEventMap {
        'drag-line-end': CustomEvent<DragEnd>;
        'drag-line-invalidate': CustomEvent<undefined>;
        'drag-line-start': CustomEvent<undefined>;
    }
    interface HTMLElementTagNameMap {
        'drag-line': DragLine;
    }
}
/** @slot - LineElement. */
export declare class DragLine extends LitElement {
    #private;
    static styles: CSSResult;
    constructor();
    protected render(): TemplateResult;
}
