import { CSSResult, LitElement, type PropertyValues, type TemplateResult } from 'lit';
import type { Line } from '../tree/text-tree.js';
import type { Context } from './context.js';
export type BlurLine = Readonly<Line>;
export type FocusLine = Readonly<Line>;
declare global {
    interface HTMLElementEventMap {
        /** Hack: internal event. Defined to workaround lit-plugin lint. */
        beforeinput: InputEvent;
        /** Break text requested at cursor. */
        'blur-line': CustomEvent<BlurLine>;
        'break-text': CustomEvent<number>;
        /** Text changed to. */
        'edit-text': CustomEvent<string>;
        'focus-line': CustomEvent<FocusLine>;
    }
    interface HTMLElementTagNameMap {
        'line-input': LineInput;
    }
}
/** Editable single line of text that grows to fit content. */
export declare class LineInput extends LitElement {
    #private;
    static styles: CSSResult;
    context: Readonly<Context>;
    line?: Readonly<Line>;
    private _p;
    private _spellcheck;
    constructor();
    protected render(): TemplateResult;
    protected shouldUpdate(props: PropertyValues<this> & PropertyValues<{
        _spellcheck: boolean;
    }>): boolean;
    getSelection(): Selection | null;
}
