var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { css, CSSResult, html, LitElement, nothing } from 'lit';
import { customElement, property, state } from 'lit/decorators.js';
import { keyed } from 'lit/directives/keyed.js';
import { repeat } from 'lit/directives/repeat.js';
import { cssReset } from '../utils/css-reset.js';
import './drag-line.js';
import './note-card.js';
let LineList = class LineList extends LitElement {
    static { this.styles = css `
    ${cssReset}

    :host {
      display: flex;
      align-items: flex-start; /* Default is stretch which causes dragged children to be too wide. */
      flex-direction: column;
      /* Keep area when empty. */
      min-width: var(--note-card-width);
      min-height: 100%;
    }

    drag-line {
      margin-top: 1px;
    }

    :not(:empty) {
      margin-inline-start: var(--indent);
    }
  `; }
    constructor() {
        super();
        this.context = {};
        this._invalidate = Symbol();
        this.addEventListener('drag-line-invalidate', ev => {
            this._invalidate = Symbol();
            ev.stopPropagation();
        });
    }
    render() {
        const lines = repeat(this.list?.down ?? [], line => line.id, line => line.type === 'EOL'
            ? nothing
            : // to-do: shouldn't assume note-card here.
                html `<drag-line
              ><note-card .context=${this.context} .line=${line}></note-card
            ></drag-line>`);
        return html `${keyed(this._invalidate, lines)}`;
    }
};
__decorate([
    property({ attribute: false })
], LineList.prototype, "context", void 0);
__decorate([
    property({ attribute: false })
], LineList.prototype, "list", void 0);
__decorate([
    state()
], LineList.prototype, "_invalidate", void 0);
LineList = __decorate([
    customElement('line-list')
], LineList);
export { LineList };
//# sourceMappingURL=line-list.js.map