import { CSSResult, LitElement, type TemplateResult } from 'lit';
import type { Line } from '../tree/text-tree.js';
import type { Context } from './context.js';
import type { LineEl } from './line-el.js';
import './line-input.js';
import './line-list.js';
export type BreakLine = {
    line: Readonly<Line>;
    at: number;
};
export type EditLine = {
    line: Readonly<Line>;
    text: string;
};
export type ExpandLine = {
    line: Readonly<Line>;
    expand: boolean;
};
export type RemoveLine = {
    line: Readonly<Line>;
};
declare global {
    interface HTMLElementEventMap {
        'break-line': CustomEvent<BreakLine>;
        'edit-line': CustomEvent<EditLine>;
        'expand-line': CustomEvent<ExpandLine>;
        'remove-line': CustomEvent<BreakLine>;
    }
    interface HTMLElementTagNameMap {
        'note-card': NoteCard;
    }
}
export declare class NoteCard extends LitElement implements LineEl {
    #private;
    static styles: CSSResult;
    context: Readonly<Context>;
    line?: Readonly<Line>;
    private _input;
    protected render(): TemplateResult;
    get rect(): DOMRect;
}
