var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { css, CSSResult, html, LitElement } from 'lit';
import { customElement, query } from 'lit/decorators.js';
import { cssReset } from '../utils/css-reset.js';
let SplitBlock = class SplitBlock extends LitElement {
    static { this.styles = css `
    ${cssReset}

    :host {
      /* Fill area. */
      display: flex;
      width: 100%;
      height: 100%;

      overflow: hidden; /* Limit width. */
    }

    .handle {
      position: relative; /* Position child relatively. */

      /* Render handle indicator; child is invisible. */
      background-color: black;
      height: 100%;
      width: 1px;
    }

    .handle:has(hr:hover) {
      background-color: red;
    }

    hr {
      opacity: 0; /* Hide. Parent is visible. */

      position: absolute; /* Remove from layout. */

      /* Make handle wide and fit the parent. If it's too wide, it blocks drag
         scrolling. */
      width: 9px;
      height: 100%;
      margin: 0;

      /* Center relative parent. */
      left: -4px;

      flex-grow: 0;

      cursor: ew-resize;
    }

    [name='lhs'] {
      display: block;
      flex-shrink: 1;
      width: 100%;
      height: 100%;
      overflow: auto;
      resize: horizontal;
    }

    [name='rhs'] {
      display: block;
      height: 100%;
      flex-basis: 0;
      flex-shrink: 1;
      flex-grow: 9999;
      overflow: auto;
    }
  `; }
    // to-do: make handle friendly
    render() {
        return html `
      <slot name="lhs"></slot>
      <div class="handle"><hr @pointerdown=${this.#onStartResize} /></div>
      <slot name="rhs"></slot>
    `;
    }
    #onEndResize(ev) {
        ev.currentTarget.onpointercancel = null;
        ev.currentTarget.onpointerup = null;
        ev.currentTarget.onpointermove = null;
        ev.currentTarget.releasePointerCapture(ev.pointerId);
    }
    #onResize(ev) {
        // to-do: fix resize on corner drag too.
        if (ev.clientX + 16 > this.clientWidth)
            this._lhs.style.width = '';
        // zap away so that window resize doesn't cause the split to reappear
        else
            this._lhs.style.width = `${ev.clientX}px`;
    }
    #onStartResize(ev) {
        // to-do: what am I doing here? why do i think it's ok to change on* props?
        ev.currentTarget.setPointerCapture(ev.pointerId);
        ev.currentTarget.onpointermove = ev => this.#onResize(ev);
        ev.currentTarget.onpointercancel = ev.currentTarget.onpointerup = ev => this.#onEndResize(ev);
    }
};
__decorate([
    query('slot[name="lhs"]')
], SplitBlock.prototype, "_lhs", void 0);
SplitBlock = __decorate([
    customElement('split-block')
], SplitBlock);
export { SplitBlock };
//# sourceMappingURL=split-block.js.map