import { TextTree } from '../tree/text-tree.js';
export type Autosave = {
    /** Filename last saved as. */
    readonly filename: string | undefined;
    /** Whether all changes have been recorded to disk. */
    readonly saved: boolean;
    readonly text: string;
    /**
     * Autosave version recorded at save time. Used for unpacking old data if
     * structural changes have been made. Independent of package.json version.
     */
    readonly version: 1;
};
export declare function saveStorage(filename: string | undefined, saved: boolean, tree: Readonly<TextTree>): void;
export declare function loadStorage(): Autosave | undefined;
