/** String-encoded data type of the text value. */
export type LineType = 
/** Data URI but not a known image media type. */
'uri-data' | 'uri-http' | 'uri-file'
/** An image URI or filename. Takes precedence over other URI line types. */
 | 'image'
/** Nonempty string. */
 | 'text'
/** Finite number. */
 | 'number'
/** True or false. */
 | 'boolean'
/** Whitespace-only string. */
 | 'blank'
/** No value. */
 | 'empty';
/** Infer the string-encoded data type of the text value. */
export declare function parseLineType(text: string): LineType;
